=== debian/changelog ===
avogadro (1.101.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
  * update Build-Depends: libavogadro-dev (>= 1.101~)
  * debian/copyright: metainfo file moved to metainfo subdir
  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Tue, 16 Sep 2025 01:33:33 +0200
