=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

export CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS) -fPIC
export CFLAGS   := $(CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS := $(CPPFLAGS) $(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS  := -fPIC $(shell dpkg-buildflags --get LDFLAGS) -Wl,-z,defs

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DQT_VERSION=6 \
	-DCMAKE_SKIP_RPATH=TRUE \
	-DAvogadro_ENABLE_RPC=OFF \
	-DBUILD_DOCUMENTATION=ON \
	  -DChemData_SOURCE_DIR=$(CURDIR) \
	  -DChemData_BINARY_DIR=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_build:
	dh_auto_build
	cd obj-$(DEB_HOST_GNU_TYPE); make documentation

# upstream installs generic docs in an odd location.
# We want them in /usr/share/doc/avogadro, so install first in tmp
override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp
	cp -r obj-$(DEB_HOST_GNU_TYPE)/docs/html debian/tmp

override_dh_clean:
	dh_clean conf.log conf.pri
