=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%avogadro-$1.tar.gz%" \
    https://github.com/OpenChemistry/avogadroapp/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
